var app = getApp()
import QR from '../../utils/QRcode';
import $http from '../../API/http';
const aes = require('./../../utils/aeskey.js');
let timeRefreshQRcode = '';
Page({
  data: {
    src: './background.png',
    title: '123123123123',
    imgPath: '',
    className: '',
    size: 272,
    url: '',
    ecc: 2,
  },
  onLoad(query) {
    // 页面加载
    const _that = this;
    dd.setNavigationBar({
      title: '付款码'
    });
  },
  // 点击刷新二维码
  clickRefreshQRcode(){
    const _that = this;
    clearInterval(timeRefreshQRcode);
    _that.refreshQRcode();
    timeRefreshQRcode = setInterval(function () {
      _that.refreshQRcode();
    }, 55000);
  },
  // 生成二维码
  refreshQRcode(){
    const _that = this;
    let hasToken = dd.getStorageSync({ key: 'token' }).data;
    let token = dd.getStorageSync({ key: 'token' }).data.access_token;
    let expires_in = dd.getStorageSync({ key: 'token' }).data.expires_in;
    let refresh_token = dd.getStorageSync({ key: 'token' }).data.refresh_token;

    if(!!hasToken && ((new Date()).getTime() - hasToken.loginTime < (hasToken.expires_in - 60) * 1000)) {
      // if(!!hasToken && ((new Date()).getTime() - hasToken.loginTime < 30 * 1000)) {
      let timestamp = (new Date()).getTime();
      let url = aes.getAES(JSON.stringify({ 
        "token": token,
        "timestamp": timestamp,
      }))
      let size = 272
      let ecc = 2
      let name = 'myQrcode'
      console.log(111111111111)
      const ctx = dd.createCanvasContext(name);
      QR.draw(url, ctx, size, Number(ecc));
      console.log(11111111111111)
    }
    else {
      dd.getNetworkType({
        success: (res => {
          // 网络可用的情况下 刷新token
          if(res.networkAvailable) {
            dd.httpRequest({
              headers: {
                'Authorization': 'Basic bWluZ3BheS1waG9uZTptaW5ncGF5LXBob25l',
                'Content-Type': 'application/x-www-form-urlencoded'
              },
              url: `http://${app.globalData.globalUrl}/auth/oauth/token`,
              dataType: 'json',
              data: {
                grant_type: 'refresh_token',
                refresh_token: refresh_token
              },
              method: 'POST',
              success: function(res) {
                console.log(res)
                dd.setStorageSync({
                  key: 'token',
                  data: {
                    access_token: res.data.access_token,
                    expires_in: res.data.expires_in,
                    refresh_token: res.data.refresh_token,
                    loginTime: (new Date()).getTime()
                  }
                })
                _that.setData({
                  b:1
                })
                hasToken = dd.getStorageSync({ key: 'token' }).data;
                token = dd.getStorageSync({ key: 'token' }).data.access_token;
                expires_in = dd.getStorageSync({ key: 'token' }).data.expires_in;
                refresh_token = dd.getStorageSync({ key: 'token' }).data.refresh_token;

                let timestamp = (new Date()).getTime();
                let url = aes.getAES(JSON.stringify({ 
                  "token": token,
                  "timestamp": timestamp,
                 }))
                let size = 272
                let ecc = 2
                let name = 'myQrcode'
                const ctx = dd.createCanvasContext(name);
                QR.draw(url, ctx, size, Number(ecc));
                
              },
              fail: function(res) {
                dd.alert({
                  content: '系统繁忙',
                  buttonText: '确定'
                })
                dd.hideLoading()
              }
            })
          }
          else {
            dd.alert({
              content: '请连接网络后重新进入',
              buttonText: '确定'
            })
            dd.hideLoading()
          }
        })
       
      })
    
    }
  
    // let timestamp = (new Date()).getTime();
    // let url = aes.getAES(JSON.stringify({ 
    //   "token": token,
    //   "timestamp": timestamp,
    // }))
    // let size = 272
    // let ecc = 2
    // let name = 'myQrcode'
    // const ctx = dd.createCanvasContext(name);
    // QR.draw(url, ctx, size, Number(ecc));
  },
  onReady() {
    // 页面加载完成
    console.log(' onReady')
    clearInterval(timeRefreshQRcode);
    const _that = this;
    _that.refreshQRcode();
    timeRefreshQRcode = setInterval(function () {
      _that.refreshQRcode();
    }, 55000);
  },
  onShow() {
    console.log('进入onshow')
    //刷新二维码
    clearInterval(timeRefreshQRcode);
    const _that = this;
    _that.refreshQRcode();
    timeRefreshQRcode = setInterval(function () {
      _that.refreshQRcode();
    }, 55000);
      
    //页面显示
    dd.connectSocket({
      url: `ws://${app.globalData.globalUrl}/v1/mingpaywebsocket?param=${dd.corpId}_${dd.getStorageSync({ key: 'userId' }).data}`,
      data: {},
      header:{
        'content-type': 'application/json',
        'Authorization': `Bearer ${dd.getStorageSync({ key: 'token' }).data.access_token}`
      },
      method:"GET",
    });
    dd.onSocketOpen(function(res) {
      console.log('WebSocket 连接已打开！');
    });
    dd.onSocketError(function(res){
      console.log('WebSocket 连接打开失败，请检查！');
    });
    dd.onSocketMessage(function(res) {
      console.log(JSON.parse(res.data))
      let resData = JSON.parse(res.data)
      if(resData.paymentCode === 0){
        dd.redirectTo({
          url: `./../paySuccess/paySuccess?money=${(JSON.parse(res.data).orderAmount).toFixed(2)}`
        })
      }else if(resData.paymentCode === 10001){
        dd.alert({
          content: '账户状态异常',
          buttonText: '确定'
        });
      }else if(resData.paymentCode === 10002){
        dd.alert({
          content: '卡片状态异常',
          buttonText: '确定'
        });
      }else if(resData.paymentCode === 10003){
        dd.alert({
          content: '账户余额不足',
          buttonText: '确定'
        });
      }else if(resData.paymentCode === 10004){
        dd.alert({
          content: '二维码失效',
          buttonText: '确定'
        });
      }
    })
    
  },
  onHide() {
    // 页面隐藏
    dd.offSocketMessage()
    dd.onSocketClose(function(res) {
      console.log('WebSocket 已关闭！')
    })
    clearInterval(timeRefreshQRcode);
  },
  onUnload() {
    // 页面被关闭
    const _that = this;
    clearInterval(timeRefreshQRcode);
    dd.offSocketMessage()
    dd.closeSocket()
    dd.onSocketClose(function(res) {
      console.log('WebSocket 已关闭！')
    })
  },
  onTitleClick() {
    // 标题被点击
  },
  onPullDownRefresh() {
    // 页面被下拉
  },
  onReachBottom() {
    // 页面被拉到底部
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
